---     

Declare @l int
SELECT @l = Count(name) from syscolumns where name = 'ur_litso' 
    and id = ( select id from sysobjects where name = 'nt_l_keywords')
if @l = 0 
begin
  alter table nt_l_keywords add ur_litso varchar(15) null
end
go


Declare @l int
select @l = count(key_f) from nt_l_keywords where key_f = 'stat1_1'
if @l = 0
  insert into nt_l_keywords (key_f,keyword_,value_,ur_litso)
  values ('stat1_1','-1:  ','xxx,xxx',1)
go



Declare @l int
select @l = count(key_f) from nt_l_keywords where key_f = 'stat1_2'
if @l = 0
  insert into nt_l_keywords (key_f,keyword_,value_,ur_litso)
  values ('stat1_2','-1:     ','xxx,xxx',1)
go

Declare @l int
select @l = count(key_f) from nt_l_keywords where key_f = 'stat1_3'
if @l = 0
  insert into nt_l_keywords (key_f,keyword_,value_,ur_litso)
  values ('stat1_3','1:  (, ,   .)','xxx,xxx',1)
go

Declare @l int
select @l = count(key_f) from nt_l_keywords where key_f = 'stat1_4'
if @l = 0
  insert into nt_l_keywords (key_f,keyword_,value_,ur_litso)
  values ('stat1_4','1:  ()','xxx,xxx',1)
go

Declare @l int
select @l = count(key_f) from nt_l_keywords where key_f = 'stat1_5'
if @l = 0
  insert into nt_l_keywords (key_f,keyword_,value_,ur_litso)
  values ('stat1_5','1:    ','xxx,xxx',1)
go

Declare @l int
select @l = count(key_f) from nt_l_keywords where key_f = 'stat1_6'
if @l = 0
  insert into nt_l_keywords (key_f,keyword_,value_,ur_litso)
  values ('stat1_6','1:   ','xx,xx',1)
go




if object_id('dbo.stat1_report_2015') is not null
begin
  drop table stat1_report_2015
end  

CREATE TABLE [dbo].[stat1_report_2015] (
  [id_user] int NULL,
  [okpo] varchar(30) null ,
  [pred] char(70) null ,
  [adress] varchar(200)  NULL,
   count_less_min int null,
   count_nepoln int null,
   spis_osn_rab int,
   spis_begin int,
   fzp_osn_rab decimal(16,5) null,
   fzp_all decimal(16,5) null
)

if object_id('dbo.stat1_report_2015_cycle') is not null
begin
  drop table stat1_report_2015_cycle
end  

CREATE TABLE [dbo].[stat1_report_2015_cycle] (
  [id_user] int NULL,
   min_ decimal(16,2) null,
   max_ decimal(16,2) null,
   count_ int null,
   sum_ decimal(16,5) null,
   text_ varchar(100) null,
   n_row varchar(2) null
)


----  
------------------------------
if object_id('dbo.usp_fill_brv_days') is not null 
begin
  drop procedure dbo.usp_fill_brv_days
end
go


set ANSI_NULLS ON
set QUOTED_IDENTIFIER ON
go


create procedure [dbo].[usp_fill_brv_days]
  @p_start_mm int,
  @p_end_mm int,
  @p_yy int
as
begin
  	---     

    insert into #brv_days
    (
  key_head,
  key_tv,
  dd,
  mm,
  yy,
  hours,
  hours_decimal,
  date_
) 
	select key_head,key_tv, 
	nums.n dd,mm,yy,
	(case when n = 1 then d1
		 when n = 2 then d2
		 when n = 3 then d3
		 when n = 4 then d4
		 when n = 5 then d5
		 when n = 6 then d6
		 when n = 7 then d7
		 when n = 8 then d8
		 when n = 9 then d9
		 when n = 10 then d10
		 when n = 11 then d11
		 when n = 12 then d12
		 when n = 13 then d13
		 when n = 14 then d14
		 when n = 15 then d15
		 when n = 16 then d16
		 when n = 17 then d17
		 when n = 18 then d18
		 when n = 19 then d19
		 when n = 20 then d20
		 when n = 21 then d21
		 when n = 22 then d22
		 when n = 23 then d23
		 when n = 24 then d24
		 when n = 25 then d25
		 when n = 26 then d26
		 when n = 27 then d27
		 when n = 28 then d28
		 when n = 29 then d29
		 when n = 30 then d30
		 when n = 31 then d31 end) hours,
		 convert (numeric(16,5),0) hours_decimal,
		 convert(datetime,null) date_
	from t7_plan_days,
	nums
	where  mm >= @p_start_mm and mm <= @p_end_mm
	and yy = @p_yy
	and key_tv = '1'
        and n<=31

	--    ( 30   ..)
	delete from #brv_days where dd > day(dateadd(dd,-1,
	dateadd(mm,1,convert(datetime,'1' + '.' + 
	convert(varchar(10),mm) + '.' + convert(varchar(10),yy),104))))


	update #brv_days set date_ = 
	convert(datetime,convert(varchar(10),dd) + '.' 
	+ convert(varchar(10),mm) + '.' + convert(varchar(10),yy),104)


	---  
    update #brv_days 
    set hours = replace(hours,',','.')

	---  8:45  8  45 
    ---   8.45   
    update #brv_days
    set hours = replace(hours,'.',':')

	update #brv_days 
	set hours_decimal  = 
	convert(numeric(16,5),substring(hours,1,charindex(':',hours) - 1)) +
	convert(numeric(16,5), substring(hours,charindex(':',hours) + 1, len(hours) - charindex(':',hours) )/60.0 )
	where charindex(':',hours) > 0 


	update #brv_days set hours_decimal  = 
	convert(numeric(16,5),hours)
	where isnumeric(hours) = 1
	and charindex(':',hours) = 0

    /*
	update #brv_days set hours_decimal = 0 
	where hours is null or isnumeric(hours) = 0
    */
end
go

if object_id('dbo.usp_fill_brv_days') is not null 
  GRANT EXECUTE ON dbo.usp_fill_brv_days TO AitUsers
GO
------------------------------------------------------------------------
if object_id('dbo.usp_fill_pers_days') is not null 
begin
  drop procedure dbo.usp_fill_pers_days
end
go

set ANSI_NULLS ON
set QUOTED_IDENTIFIER ON
go

create procedure [dbo].[usp_fill_pers_days]
@p_user_id int, @p_start_mm int, 
@p_end_mm int, @p_yy int, @p_header_keyf varchar(15) 
as
begin

if object_id('tempdb..#brv_pers_days_const') is not null
begin
  drop table #brv_pers_days_const
end

declare @p_start_date datetime,@p_end_date datetime

set @p_start_date = convert(datetime,('01-' + cast(@p_start_mm as varchar(2)) +'-'+cast(@p_yy as varchar(4))),104)
set @p_start_date = dateadd(dd,-1,@p_start_date)
set @p_end_date = convert(datetime,('01-' + cast (@p_end_mm as varchar (2)) + '-'+cast (@p_yy as varchar(4))),104)
set @p_end_date = dateadd(mm,1,@p_end_date)

---  
select const.pers_id 
into #brv_pers_days_const
from pbpers4user,const 
where header_key_f = @p_header_keyf and 
const.pers_id = pbpers4user.pers_id and
(const.date_post <= dateadd(dd,1,@p_start_date) or const.date_post is null) and 
(const.date_out> dateadd(dd,-1,@p_end_date) or const.date_out is null)




---    

EXEC	[dbo].[usp_fill_brv_days]
		@p_start_mm = @p_start_mm,
		@p_end_mm = @p_end_mm,
		@p_yy = @p_yy

if object_id('tempdb..#stat1_y_jur_dot2') is not null
begin
   drop table #stat1_y_jur_dot2
end


select * into #stat1_y_jur_dot2 from y_jur_dot2
where pers_id in
(
select pers_id from #brv_pers_days_const
)
and when_ < @p_end_date and when_ended > @p_start_date

update #stat1_y_jur_dot2
set when_ = (case when when_ < dateadd(dd,1,@p_start_date) or when_ is null then dateadd(dd,1,@p_start_date) else when_ end),
    when_ended = (case when when_ended > dateadd(dd,-1,@p_end_date) or when_ended is null 
    then dateadd(dd,-1,@p_end_date) else when_ended end)

---     
insert into #brv_pers_days
(pers_id, key_head, hours_decimal,date_)
select pers_id, key_head, hours_decimal,date_ 
from #brv_days bd,#stat1_y_jur_dot2  sy
where bd.date_ >= sy.when_ and bd.date_ <= sy.when_ended
and bd.key_head = sy.brv



--- ,      const,    ...

insert into #brv_pers_days
(pers_id, key_head, hours_decimal,date_)
select pers_id, key_head, hours_decimal,date_ 
from #brv_days bd,const
where bd.date_ > @p_start_date and bd.date_ < @p_end_date
and bd.key_head = const.brv
and const.pers_id in
(select pers_id from #brv_pers_days_const)
and not exists
(select 1 from #stat1_y_jur_dot2 sy
where sy.pers_id = const.pers_id)
end
go


if object_id('dbo.usp_fill_pers_days') is not null 
  GRANT EXECUTE ON dbo.usp_fill_pers_days TO AitUsers
GO
------------------------------------------------------------------------

set ANSI_NULLS ON
set QUOTED_IDENTIFIER ON
go


if object_id('dbo.usp_f1_report_2015') is not null 
begin
  drop procedure dbo.usp_f1_report_2015
end
go

create PROCEDURE [dbo].[usp_f1_report_2015] 
@p_user_id int, @p_start_mm int, 
@p_end_mm int, @p_yy int, @p_header_keyf varchar(15) 
AS
begin
set nocount on
/*
declare @p_user_id int, @p_start_mm int, @p_end_mm int, @p_yy int, @p_header_keyf varchar(15) 

--  
set @p_user_id = 1
set @p_start_mm = 1 
set @p_end_mm = 12 
set @p_yy = 2004 
set @p_header_keyf = 'w_nlg_1' 
*/ 

declare @p_start_date datetime,@p_end_date datetime

set @p_start_date = convert(datetime,('01-' + cast(@p_start_mm as varchar(2)) +'-'+cast(@p_yy as varchar(4))),104)
set @p_start_date = dateadd(dd,-1,@p_start_date)
set @p_end_date = convert(datetime,('01-' + cast (@p_end_mm as varchar (2)) + '-'+cast (@p_yy as varchar(4))),104)
set @p_end_date = dateadd(mm,1,@p_end_date)


delete from stat1_report_2015 where id_user = @p_user_id
delete from stat1_report_2015_cycle where id_user = @p_user_id

--  
insert stat1_report_2015(id_user, pred, adress)
select @p_user_id, u.pred, u.adress
from  ust u

-- 
update stat1_report_2015 
set okpo = u.okpo
from ust_nlg u
where id_user = @p_user_id


CREATE TABLE #brv_days (
  [key_head] varchar(15) null,
  [key_tv] varchar(15) null,
  [dd] int NULL,
  [mm] decimal(2, 0) NULL,
  [yy] decimal(4, 0) NULL,
  [hours] varchar(20) NULL,
  [hours_decimal] numeric(16, 5) NULL,
  [date_] datetime NULL
)



---      
CREATE TABLE #brv_pers_days (
  [pers_id] varchar(15) NULL,
  [key_head] varchar(15) NULL,
  [hours_decimal] numeric(16, 5) NULL,
  [date_] datetime NULL
)

create clustered index idx_temp_brv_pers_days on #brv_pers_days(pers_id,date_)

---      
exec usp_fill_pers_days
@p_user_id = @p_user_id, @p_start_mm = @p_start_mm, 
@p_end_mm = @p_end_mm, @p_yy = @p_yy, @p_header_keyf = @p_header_keyf

--         
select const.pers_id into #stat1_const from pbpers4user,const 
where header_key_f = @p_header_keyf and 
const.pers_id = pbpers4user.pers_id and
(const.date_post <= dateadd(dd,1,@p_start_date) or const.date_post is null) and 
(const.date_out> dateadd(dd,-1,@p_end_date) or const.date_out is null)  and
( isnull(const.fl_sovmest,'') <> '1' )

---  
---    
--delete from #stat1_const 
--where pers_id in 
--(select pers_id from const  where isnull(fl_sovmest,'')='1')


--- 
declare @dogov varchar (255)
select @dogov = ''

select @dogov = value_ from nt_l_keywords where keyword_ = '-1:  '

create table #stat1_dogov (code varchar(10))

while charindex (',',@dogov,1)>0
begin
	insert into #stat1_dogov values (rtrim(ltrim(substring(@dogov,1,charindex(',',@dogov,1)-1))))
	set @dogov = substring(@dogov,charindex(',',@dogov,1)+1,len(@dogov)-charindex(',',@dogov,1))
end
if len (@dogov)>0 insert into #stat1_dogov values(rtrim(ltrim(@dogov)))

---       - 
---        ,    delete
--- ,     

delete from #stat1_const 
where pers_id in 
(
select #stat1_const.pers_id from arhiv_ras,#stat1_const
where arhiv_ras.pers_id = #stat1_const.pers_id and ras_mm = @p_end_mm and ras_yy = @p_yy
and code<'500' and code in (select code from #stat1_dogov)
)


--  2.5 -       > 5   
declare @adm_otp varchar(255)

set @adm_otp = ''
select @adm_otp = value_ from nt_l_keywords where keyword_ = '-1:     '
create table #stat1_adm_otp (code varchar(10))

--       
while charindex(',',@adm_otp,1)>0
begin
	insert into #stat1_adm_otp values (rtrim(ltrim(substring(@adm_otp,1,charindex(',',@adm_otp,1)-1))))
	set @adm_otp = substring(@adm_otp,charindex(',',@adm_otp,1)+1,len(@adm_otp)-charindex(',',@adm_otp,1))
end
if len(@adm_otp)>0 insert into #stat1_adm_otp values (rtrim(ltrim(@adm_otp)))

---      

-- 2       -      -   
--  

delete from #stat1_const 
where exists
(
  select 1 from contr_kdr
where contr_kdr.pers_id = #stat1_const.pers_id and 
vid_contr in (select key_f from sp_vid_contr where tip_contr = '1') and (date_begin<@p_end_date or date_begin is null) and 
(date_end > @p_start_date or date_end is null) 
)



------==================================
-- ,      
select distinct y_jur_otp.pers_id  into #stat1_spis_adm from y_jur_otp,#stat1_const where
y_jur_otp.pers_id = #stat1_const.pers_id  
and date_end > @p_start_date and date_begin < @p_end_date 
and otp_tip in (select code from #stat1_adm_otp)

--   ,       <= 5 
--  5   (         
--    ,   hours_decimal = 0  -   )
delete from #stat1_spis_adm
where 
isnull(
		 (select sum(rab_days) from
		 ( 
			select (datediff(dd,date_begin,date_end)+1) - 
			isnull((select count(*) from #brv_pers_days bpd 
			where bpd.date_ >= date_begin 
			and date_ <= date_end 
			and bpd.hours_decimal = 0 
			and bpd.pers_id = y_jur_otp.pers_id),0) rab_days
			from y_jur_otp,
			#stat1_spis_adm 
			where
			y_jur_otp.pers_id = #stat1_spis_adm.pers_id  and date_end > @p_start_date 
			and date_begin < @p_end_date 
			and otp_tip in (select code from #stat1_adm_otp)
		 ) tt)
     ,0) <= 5

--  ,      ,  
--    5 
--    

delete from #stat1_const where pers_id in 
(select pers_id from #stat1_spis_adm)
----------------==================================
---------=============================================================
--- 2.4     , .     

declare @child_otp varchar(255)

set @child_otp = ''
select @child_otp = value_ from nt_l_keywords where keyword_ = '1:  (, ,   .)'
create table #stat1_child_otp (code varchar(10))

--       
while charindex(',',@child_otp,1)>0
begin
	insert into #stat1_child_otp values (rtrim(ltrim(substring(@child_otp,1,charindex(',',@child_otp,1)-1))))
	set @child_otp = substring(@child_otp,charindex(',',@child_otp,1)+1,len(@child_otp)-charindex(',',@child_otp,1))
end
if len(@child_otp)>0 insert into #stat1_child_otp values (rtrim(ltrim(@child_otp)))

------==================================
--   ,    , 
--   
delete from #stat1_const
where exists
(
select 1
from y_jur_otp where
y_jur_otp.pers_id = #stat1_const.pers_id  
and date_end > @p_start_date and date_begin < @p_end_date
and otp_tip in (select code from #stat1_child_otp)
)
------==================================
--- 2.3 
--   ,      
delete from #stat1_const
where exists
(
select 1
from y_jur_bl where
y_jur_bl.pers_id = #stat1_const.pers_id  
and date_end > @p_start_date and date_begin < @p_end_date 
)
------==================================
----------  ,    5     

declare @t7_types varchar(255)

set @t7_types = ''
select @t7_types = value_ from nt_l_keywords where keyword_ = '1:  ()'
create table #stat1_t7_types (tv varchar(15))

--       
while charindex(',',@t7_types,1)>0
begin
	insert into #stat1_t7_types 
    select key_f from t7_tv 
    where code_f = 
    (rtrim(ltrim(substring(@t7_types,1,charindex(',',@t7_types,1)-1))))
	set @t7_types = substring(@t7_types,charindex(',',@t7_types,1)+1,len(@t7_types)-charindex(',',@t7_types,1))
end
if len(@t7_types)>0 
begin
  insert into #stat1_t7_types 
  select key_f from t7_tv 
  where code_f = (rtrim(ltrim(@t7_types)))
end




select pers_id,key_tv, 
  nums.n dd,mm,yy,
(case when n = 1 then d1
     when n = 2 then d2
     when n = 3 then d3
     when n = 4 then d4
     when n = 5 then d5
     when n = 6 then d6
     when n = 7 then d7
     when n = 8 then d8
     when n = 9 then d9
     when n = 10 then d10
     when n = 11 then d11
     when n = 12 then d12
     when n = 13 then d13
     when n = 14 then d14
     when n = 15 then d15
     when n = 16 then d16
     when n = 17 then d17
     when n = 18 then d18
     when n = 19 then d19
     when n = 20 then d20
     when n = 21 then d21
     when n = 22 then d22
     when n = 23 then d23
     when n = 24 then d24
     when n = 25 then d25
     when n = 26 then d26
     when n = 27 then d27
     when n = 28 then d28
     when n = 29 then d29
     when n = 30 then d30
     when n = 31 then d31 end) hours,
     convert(numeric(16,5),0) hours_decimal,
     convert(datetime,null) date_
into #stat1_tabel_lists
from tu_day_list,
  nums
where pers_id in 
(select pers_id from #stat1_const)
and mm >= @p_start_mm and mm <= @p_end_mm
and yy = @p_yy and n<=31
and key_tv in
--   +  
  ( select tv from #stat1_t7_types union all select '1')

--         

   --    ( 30   ..)
	delete from #stat1_tabel_lists where dd > day(dateadd(dd,-1,
	dateadd(mm,1,convert(datetime,'1' + '.' + 
	convert(varchar(10),mm) + '.' + convert(varchar(10),yy),104))))


	update #stat1_tabel_lists set date_ = 
	convert(datetime,convert(varchar(10),dd) + '.' 
	+ convert(varchar(10),mm) + '.' + convert(varchar(10),yy),104)


    update #stat1_tabel_lists 
    set hours = replace(hours,',','.')

	---  8:45  8  45 
    ---   8.45   
    update #stat1_tabel_lists
    set hours = replace(hours,'.',':')

	update #stat1_tabel_lists 
	set hours_decimal  = 
	convert(numeric(16,5),substring(hours,1,charindex(':',hours) - 1)) +
	convert(numeric(16,5), substring(hours,charindex(':',hours) + 1, len(hours) - charindex(':',hours) )/60.0 )
	where charindex(':',hours) > 0 


	update #stat1_tabel_lists 
    set hours_decimal  = 
	convert(numeric(16,5),hours)
	where isnumeric(hours) = 1
	and charindex(':',hours) = 0

    /*
	update #stat1_tabel_lists set hours_decimal = 0 
	where hours is null or isnumeric(hours) = 0
    */

---       ,   





select pers_id, key_tv,
sum(case when hours_decimal >0 then 1 else 0 end) sum_days
into #stat1_tabel_lists_sums
from #stat1_tabel_lists
where key_tv in ( select tv from #stat1_t7_types )
group by pers_id, key_tv


--  ,           > 5

delete from #stat1_const
where exists
(
select 1 from #stat1_tabel_lists_sums where sum_days > 5 and #stat1_tabel_lists_sums.pers_id = #stat1_const.pers_id
)

--- 2.x  ,      

declare @p_stop_brvs varchar(255)
select @p_stop_brvs = value_ from nt_l_keywords where keyword_ = 
	'1:   '
create table #stat1_stop_brvs(stop_brv varchar(15))

--,   
while charindex(',',@p_stop_brvs,1)>0
begin
	insert into #stat1_stop_brvs values 
    	(rtrim(ltrim(substring(@p_stop_brvs,1,charindex(',',@p_stop_brvs,1)-1))))
	set @p_stop_brvs = substring(@p_stop_brvs,charindex(',',@p_stop_brvs,1)+1,len(@p_stop_brvs)
    -charindex(',',@p_stop_brvs,1))
end
if len(@p_stop_brvs)>0 insert into #stat1_stop_brvs values (rtrim(ltrim(@p_stop_brvs)))

---  ,     40   ,    
--- 

delete from #stat1_const
where 
(select sum(bd.hours_decimal - sl.hours_decimal ) from #brv_pers_days bd,#stat1_tabel_lists sl
 where bd.pers_id = #stat1_const.pers_id 
 and sl.key_tv = '1'
 and bd.pers_id = sl.pers_id and bd.date_ = sl.date_
  and bd.key_head in
 (select stop_brv from #stat1_stop_brvs)) > 40
 




--------------     arhiv_ras -----
--------------    ,      


declare @p_excl_codes varchar(255)
select @p_excl_codes = value_ from nt_l_keywords where keyword_ = 
	'1:    '
create table #stat1_excl_codes(code varchar(10))

--,   
while charindex(',',@p_excl_codes,1)>0
begin
	insert into #stat1_excl_codes values 
    	(rtrim(ltrim(substring(@p_excl_codes,1,charindex(',',@p_excl_codes,1)-1))))
	set @p_excl_codes = substring(@p_excl_codes,charindex(',',@p_excl_codes,1)+1,len(@p_excl_codes)
    -charindex(',',@p_excl_codes,1))
end
if len(@p_excl_codes)>0 insert into #stat1_excl_codes values (rtrim(ltrim(@p_excl_codes)))

--      

delete from #stat1_excl_codes where code is null


      
select pers_id,
	   sum(summa) summa
into        
#stat1_people_totals       
from 
(
select
ars.pers_id,
ars.summa
from 
arhiv_ras ars
where 
ars.pers_id in
  (select pers_id from #stat1_const)
and ars.mm >= @p_start_mm and ars.mm <= @p_end_mm
and ars.yy = @p_yy
and ars.code not in
  (select code from #stat1_excl_codes)
and ars.code < '500'
)
tt
group by pers_id


insert stat1_report_2015_cycle (id_user, min_, max_, n_row, text_)
values (@p_user_id, 0.01, 11280, '01', ' 11280,0')

insert stat1_report_2015_cycle (id_user, min_, max_, n_row, text_)
values (@p_user_id, 11280.01, 12140, '02', ' 11280,1  12140,0')

insert stat1_report_2015_cycle (id_user, min_, max_, n_row, text_)
values (@p_user_id, 12140.01, 13000, '03', ' 12140,1  13000,0')

insert stat1_report_2015_cycle (id_user, min_, max_, n_row, text_)
values (@p_user_id, 13000.01, 13850, '04', ' 13000,1  13850,0')

insert stat1_report_2015_cycle (id_user, min_, max_, n_row, text_)
values (@p_user_id, 13850.01, 14700, '05', ' 13850,1  14700,0')

insert stat1_report_2015_cycle (id_user, min_, max_, n_row, text_)
values (@p_user_id, 14700.01, 15850, '06', ' 14700,1  15850,0')

insert stat1_report_2015_cycle (id_user, min_, max_, n_row, text_)
values (@p_user_id, 15850.01, 17000, '07', ' 15850,1  17000,0')

insert stat1_report_2015_cycle (id_user, min_, max_, n_row, text_)
values (@p_user_id, 17000.01, 18050, '08', ' 17000,1  18050,0')

insert stat1_report_2015_cycle (id_user, min_, max_, n_row, text_)
values (@p_user_id, 18050.01, 19200, '09', ' 18050,1  19200,0')

insert stat1_report_2015_cycle (id_user, min_, max_, n_row, text_)
values (@p_user_id, 19200.01, 20350, '10', ' 19200,1  20350,0')

insert stat1_report_2015_cycle (id_user, min_, max_, n_row, text_)
values (@p_user_id, 20350.01, 21450, '11', ' 20350,1  21450,0')

insert stat1_report_2015_cycle (id_user, min_, max_, n_row, text_)
values (@p_user_id, 21450.01, 22560, '12', ' 21450,1  22560,0')

insert stat1_report_2015_cycle (id_user, min_, max_, n_row, text_)
values (@p_user_id, 22560.01, 23690, '13', ' 22560,1  23690,0')

insert stat1_report_2015_cycle (id_user, min_, max_, n_row, text_)
values (@p_user_id, 23690.01, 24820, '14', ' 23690,1  24820,0')

insert stat1_report_2015_cycle (id_user, min_, max_, n_row, text_)
values (@p_user_id, 24820.01, 27100, '15', ' 24820,1  27100,0')

insert stat1_report_2015_cycle (id_user, min_, max_, n_row, text_)
values (@p_user_id, 27100.01, 29300, '16', ' 27100,1  29300,0')

insert stat1_report_2015_cycle (id_user, min_, max_, n_row, text_)
values (@p_user_id, 29300.01, 31600, '17', ' 29300,1  31600,0')

insert stat1_report_2015_cycle (id_user, min_, max_, n_row, text_)
values (@p_user_id, 31600.01, 33900, '18', ' 31600,1  33900,0')

insert stat1_report_2015_cycle (id_user, min_, max_, n_row, text_)
values (@p_user_id, 33900.01, 40000, '19', ' 33900,1  40000,0')

insert stat1_report_2015_cycle (id_user, min_, max_, n_row, text_)
values (@p_user_id, 40000.01, 45000, '20', ' 40000,1  45000,0')

insert stat1_report_2015_cycle (id_user, min_, max_, n_row, text_)
values (@p_user_id, 45000.01, 50000, '21', ' 45000,1  50000,0')

insert stat1_report_2015_cycle (id_user, min_, max_, n_row, text_)
values (@p_user_id, 50000.01, 60000, '22', ' 50000,1  60000,0')

insert stat1_report_2015_cycle (id_user, min_, max_, n_row, text_)
values (@p_user_id, 60000.01, 75000, '23', ' 60000,1  75000,0')

insert stat1_report_2015_cycle (id_user, min_, max_, n_row, text_)
values (@p_user_id, 75000.01, 100000, '24', ' 75000,1  100000,0')

insert stat1_report_2015_cycle (id_user, min_, max_, n_row, text_)
values (@p_user_id, 100000.01, 250000, '25', ' 100000,1  250000,0')

insert stat1_report_2015_cycle (id_user, min_, max_, n_row, text_)
values (@p_user_id, 250000.01, 500000, '26', ' 250000,1  500000,0')

insert stat1_report_2015_cycle (id_user, min_, max_, n_row, text_)
values (@p_user_id, 500000.01, 1000000, '27', ' 500000,1  1000000,0')

insert stat1_report_2015_cycle (id_user, min_, max_, n_row, text_)
values (@p_user_id, 1000000.01, 999999999, '28', ' 1000000,0')

update stat1_report_2015_cycle set count_=(
    select count(pers_id) from #stat1_people_totals
    where summa between stat1_report_2015_cycle.min_ and stat1_report_2015_cycle.max_ 
  ),
  sum_=(
    select sum(summa) from #stat1_people_totals
    where summa between stat1_report_2015_cycle.min_ and stat1_report_2015_cycle.max_ 
  )
where id_user=@p_user_id

insert stat1_report_2015_cycle (id_user, min_, max_, n_row, text_, sum_, count_ )
select @p_user_id, 0, 0, '29', '  (.  01  28)', sum(sum_), sum(count_)
from stat1_report_2015_cycle
where id_user=@p_user_id

--     -4     spis_osn_rab, fzp_osn_rab
exec sp_p4_report @id_user=@p_user_id, @mm1=@p_start_mm, @mm2=@p_end_mm, @yy=@p_yy, @kf=@p_header_keyf

update stat1_report_2015 
set stat1_report_2015.spis_osn_rab =  p4_report.spis_osn_rab,
    stat1_report_2015.fzp_osn_rab =  p4_report.fzp_osn_rab,
    stat1_report_2015.fzp_all =  p4_report.fzp_obsh,
    count_less_min=(select count_ from stat1_report_2015_cycle where id_user=@p_user_id and n_row='01'),
    count_nepoln = (
       select count(pers_id) from #stat1_people_totals
       where summa <= 11280 and pers_id in (select pers_id from #brv_pers_days where key_head in (select brv from brv where full_brv>'' and full_brv<>brv)) 
    ),
    spis_begin = (
      select count(const.pers_id) from pbpers4user,const 
      where header_key_f = @p_header_keyf and 
        const.pers_id = pbpers4user.pers_id and
        const.date_post <= dateadd(dd,1,@p_start_date) and 
        (const.date_out > @p_start_date or const.date_out is null)  and
        isnull(const.fl_sovmest,'') <> '1' 
    )
from p4_report 
where stat1_report_2015.id_user = @p_user_id and p4_report.id_user = @p_user_id

---   
if object_id('tempdb..#stat1_const') is not null
begin
   drop table #stat1_const
end

if object_id('tempdb..#stat1_dogov') is not null
begin
   drop table #stat1_dogov
end

if object_id('tempdb..#stat1_adm_otp') is not null
begin
   drop table #stat1_adm_otp
end

if object_id('tempdb..#stat1_spis_adm') is not null
begin
   drop table #stat1_spis_adm
end

if object_id('tempdb..#stat1_child_otp') is not null
begin
   drop table #stat1_child_otp
end

if object_id('tempdb..#stat1_tabel_lists') is not null
begin
   drop table #stat1_tabel_lists
end

if object_id('tempdb..#stat1_tabel_lists_sums') is not null
begin
   drop table #stat1_tabel_lists_sums
end

if object_id('tempdb..#stat1_t7_types') is not null
begin
   drop table #stat1_t7_types
end

if object_id('tempdb..#stat1_stop_brvs') is not null
begin
   drop table #stat1_stop_brvs
end

---    

if object_id('tempdb..#brv_days') is not null
begin
  drop table #brv_days 
end

if object_id('tempdb..#brv_pers_days') is not null 
begin 
  drop table #brv_pers_days
end

if object_id('tempdb..#stat1_excl_codes') is not null
begin
  drop table #stat1_excl_codes
end

if object_id('tempdb..#stat1_people_totals') is not null
begin
  drop table #stat1_people_totals
end




end /*usp_stat1_report_2015*/
go


if object_id('dbo.usp_f1_report_2015') is not null 
  GRANT EXECUTE ON dbo.usp_f1_report_2015 TO AitUsers
GO


IF NOT EXISTS (SELECT * FROM forms WHERE file_ = 'f1_stat_2019.rep')
	INSERT INTO forms (  key_f, nomer, name, file_, tip, dot_name, fl_excel, tip_file)
  VALUES ('usp_f1_19', 0, ' 1  2019','f1_stat_2019.rep', '', 'f1_stat_2019.xls', '1', 3)
GO


grant select,insert,update,delete on stat1_report_2015 to AitUsers
go
grant select,insert,update,delete on stat1_report_2015_cycle to AitUsers
go


grant execute on dbo.usp_fill_brv_days to AitUsers
go
grant execute on dbo.usp_f1_report_2015 to AitUsers
go
